# HTICQ - A Web ICQ Client
# Copyright (C) 1999  Dwayne C. Litzenberger  
#  
# This program is free software; you can redistribute it and/or modify   
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import random
import os

true  = (1==1)
false = (1==0)

IN_CLIENT = 0x00	# For IN_PROGRAM
IN_INTERFACE = 0x01

VALID_CHARS='ABCDEFGHIJKLMNOPQRSTUVWXYZ'


def exists(file):
        try:
                os.stat(file)
        except OSError,x:
                if x.errno == 2:
                        return 0
                else:
                        raise OSError,x
        return 1

def random_string(length):
        o=''
        for i in range(length):
                o = o + random.choice(VALID_CHARS)
        return o

def stri(i):
        x=str(i)
        if x[-1:] == 'L': x=x[:-1]
        return x

def noline(i):
        x = i 
        if x[-1:] == '\012': x=x[:-1]
        return x


# Bi-directional
CMD_ACK                  = 0x000A

# Server -> Client
CMD_FORCE_LOGOUT         = 0x0028
CMD_NOT_LOGGED_IN	 = 0x00f0
CMD_LOGIN_OK             = 0x005A
CMD_LOGIN_BADPWD         = 0x0064
CMD_END_OF_SEARCH        = 0x00A0
CMD_RECV_MSG             = 0x00DC
CMD_INSTANT_MSG          = 0x0104
CMD_SRV_X2               = 0x00E6
CMD_SRV_X1               = 0x021C
CMD_USER_ONLINE          = 0x006E
CMD_USER_OFFLINE         = 0x0078
CMD_STATUS_UPDATE        = 0x01A4
CMD_INFO_REPLY           = 0x0118
CMD_USER_FOUND           = 0x008C
CMD_SET_AUTH_ACK         = 0x01F4   # Hmm... Spec says 0x1FE

# Client -> Server
CMD_LOGIN                = 0x03E8
CMD_KEEPALIVE            = 0x042E
CMD_TEXT_CODE            = 0x0438
CMD_MESSAGE_ACK          = 0x0442
CMD_LOGIN_ACK            = 0x044C
CMD_CONTACTS             = 0x0406
CMD_VISIBLES             = 0x06A4	# Not here by v2 spec, but hey
CMD_INVISIBLES           = 0x06AE	# Not here by v2 spec, but hey
CMD_SEND_MSG             = 0x010E
CMD_CHANGE_STATUS        = 0x04D8
CMD_INFO_REQ             = 0x0460
CMD_REQ_ADD_TO_LIST      = 0x0456  #maybe 0x04EC
CMD_SET_AUTH             = 0x0514

# ICQ Message Types
ICQ_MSG_TEXT             = 0x0001
ICQ_MSG_CHAT             = 0x0002
ICQ_MSG_FILE             = 0x0003
ICQ_MSG_URL              = 0x0004
ICQ_MSG_REQ_AUTH         = 0x0006
ICQ_MSG_AUTHORIZED       = 0x0008
ICQ_MSG_ADDED_TO_LIST    = 0x000C
ICQ_MSG_WEB_PANEL        = 0x000D
ICQ_MSG_EMAIL_PAGER      = 0x000E
ICQ_MSG_CONTACT_LIST     = 0x0013
ICQ_MSG_USER_INFO        = 0x001A
ICQ_MSG_F_MULTIREC       = 0x8000	# Spam flag

# ICQ Status Bits
ICQ_STAT_OFFLINE               = 0xFFFF
ICQ_STAT_ONLINE                = 0x0000
ICQ_STAT_AWAY                  = 0x0001
ICQ_STAT_DND                   = 0x0002
ICQ_STAT_NA                    = 0x0004
ICQ_STAT_OCCUPIED              = 0x0010
ICQ_STAT_INVISIBLE             = 0x0100
ICQ_STAT_F_FLAGS               = 0xFFFF0000
ICQ_STATUS_FxPRIVATE           = 0x00000100	# Same as invisible
ICQ_STATUS_FxWEBxPRESENCE      = 0x00010000
ICQ_STATUS_FxHIDExIP           = 0x00020000
ICQ_STATUS_FxBIRTHDAY          = 0x00080000

# Authorization requirements

ICQ_AUTH_AUTH       = 0x00
ICQ_AUTH_ALWAYS     = 0x01

# get_events RETURN types
RETURN_HTML         = 0x00
RETURN_NUMMSGS      = 0x01
RETURN_NUMSYSMSGS      = 0x02

# Custom events - Must not conflict with CMD_*
EVNT_EDIT_MY_INFO   = 0xFFFE
