#!/usr/bin/python
# HTICQ - A Web ICQ Client
# Copyright (C) 1999  Dwayne C. Litzenberger
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# javascript:window.open("http://dlitz.dcl/cgi-bin/hticq/icq?action=StatusFrame&my_uin=19419918&session=woxyjaajbpknzxaq","HTICQPopup",'toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=0,resizable=0,width=210,height=30')

from common import *

import sys,os
import re
import time
import random
import pickle
import md5

IN_PROGRAM = IN_INTERFACE
 
DEBUG=0		# No debugging
#DEBUG=1		# Full debugging
#DEBUG=2		# Debug why messsages
CREATE_NEW=1		# Are new registrations permitted?

if DEBUG == 1:
	print "Content-type: text/html\n"
	print "*** DEBUG ***"


def copy_file(src,dest):
	f = open(src, 'r')
	g = open(dest,'w')
	g.write(f.read())				
	f.close()
	g.close()
	


def split_vars(a):
	b = a
	b = re.sub('\+', ' ', b)	# Replace '+' with ' '
	tmp = re.split('\&',b)
	y={}
	for i in range(len(tmp)):
		x = re.split('\=',tmp[i])
		o = x[1]
		l = re.split('\%', o)
		c = l[0]
		for i in range(len(l)-1):
			j = i+1
			c = c + eval('"\\x' + l[j][0:2] + '"') + l[i][2:]
		o = c
		y[x[0]] = o
	return y

def getparam(dict,p):
	try:
		o=dict[p]
	except KeyError:
		o=''
	return o

def getenv(p):
	try:
		o=os.environ[p]
	except KeyError:
		o=''
	return o

def good_password(inpwd):	# does the md5 hash of inpwd == hash file
	f=open(data_dir+"/session/hash",'r')
	goodhash=pickle.Unpickler(f).load()
	f.close()
        m=md5.new()
        m.update(inpwd)
	h=m.digest()
	if h == goodhash:
		return true
	return false

def gen_session_key():
	o=''
	for i in range(16):
		o=o+chr(random.randint(97,122))
	#o='kkk'		# XXX DEBUG
	return o
	
def write_event(eventdata):
	e=1
	while e:
		r = random_string(16)
		file = data_dir + '/session/events/i2c/' + r
		file2 = data_dir + '/session/events/i2c-temp/' + r
		if exists(file) or exists(file2):
			e=1
		else:
			e=0

	f=open(file2,'w')
	pickle.dump(eventdata,f)
	f.close()	
	os.rename(file2,file)

def isactive():
	try:
		f=open(data_dir+'/session/pid','r')
		x=''
		while x == '':
			x=f.read()
		pid=int(x)
		f.close()
		if os.path.exists("/proc/"+stri(pid)) != 0:
			return true
#		if os.system('ps ' + stri(pid) + ' >/dev/null') == 0:
#			return true
	except IOError:
		pass
	return false
		
def write_packet(pkt,inprg=IN_CLIENT):          # FIXME: should be called from common.py
        IN_PROGRAM=inprg        # This should be a super-global variable, but I$
        e=1
        if IN_PROGRAM == IN_CLIENT:
                print "W> Write Packet..."
        while e:
                r = random_string(16)
                file=data_dir + '/session/events/c2i/' + r
                file2=data_dir + '/session/events/c2i-temp/' + r
                if exists(file) or exists(file2):
                        e=1
                else:
                        e=0
        f=open(file2,'w')
        pickle.dump(pkt,f)
        f.close()
        os.rename(file2,file)
        if IN_PROGRAM == IN_CLIENT:
                print "   ...done"

def get_peerinfo():
	global peerinfo
	f=open(data_dir + '/session/peerinfo','r')
	peerinfo=pickle.Unpickler(f).load()
	f.close()

def peerinfo_sorted_keys(sortby='alias'):
	c=[]
	for u in peerinfo.keys():
	        c.append([peerinfo[u]['status']] + [peerinfo[u][sortby]] + [u])
	c.sort()
	x=[]
	for i in range(len(c)):
	        u=c[i][-1]
	        x.append(u)	
	return x

def contact_list():
	get_peerinfo()
	ctmp=''
	for k in peerinfo_sorted_keys('alias'):
		s = peerinfo[k]['status']
		if s == ICQ_STAT_OFFLINE:
			stmp = "Offline"
			a = ''
			a2 = ''
		elif s == ICQ_STAT_ONLINE:
			stmp = "Online"
			a = '<FONT COLOR="blue">'
			a2 = '</FONT>'
		elif s == ICQ_STAT_AWAY:
			stmp = "Away"
			a = '<FONT COLOR="green">'
			a2 = '</FONT>'
		elif s & ICQ_STAT_NA:
			stmp = "Not Available"
			a = '<FONT COLOR="green">'
			a2 = '</FONT>'
		elif s & ICQ_STAT_DND:
			stmp = "Do Not Disturb"
			a = '<FONT COLOR="green">'
			a2 = '</FONT>'
		elif s & ICQ_STAT_OCCUPIED:
			stmp = "Occupied"
			a = '<FONT COLOR="green">'
			a2 = '</FONT>'
		elif s & ICQ_STAT_INVISIBLE:
			stmp = "Invisible"
			a = '<FONT COLOR="red">'
			a2 = '</FONT>'
		else:
			stmp = "?" + stri(s) + "?"
			a=''
			a2=''
		ctmp = ctmp + '<INPUT TYPE="radio" NAME="uin" VALUE="' + stri(k) + '">' + a + peerinfo[k]['alias'] + ' [' + stri(k) + '] (' + stmp + ')' + a2 + '<BR>\n'
	ctmp = ctmp + '<INPUT TYPE="radio" NAME="uin" VALUE="0" CHECKED>Other: '
	ctmp = ctmp + '<INPUT TYPE="text" NAME="other_uin" VALUE="" SIZE="10"><BR>'
	return ctmp

######

def get_events(returntype=RETURN_HTML):
	events=''
	sysevents=''
	allevents=''
        nummsgs=0
	numsysmsgs=0
        lst = os.listdir(data_dir + '/session/events/c2i') 
        for i in range(len(lst)):
                file = data_dir + '/session/events/c2i/' + lst[i]
                f = open(file, 'r')
		pkt = pickle.Unpickler(f).load()
		c = pkt['cmd']
		if c == CMD_RECV_MSG or c == CMD_INSTANT_MSG:
                        nummsgs = nummsgs + 1
			extrabuttons = ''
			try:
				tmp = peerinfo[pkt['uin']]
			except KeyError:
				extrabuttons = extrabuttons + '<INPUT TYPE="submit" NAME="action" VALUE="Add to Contact List">'
			msg = pkt['message']
			msg = re.sub('\<', '&lt;', msg)
			msg = re.sub('\>', '&gt;', msg)
			msg = re.sub('\x0a', '<BR>', msg)
			msg = re.sub('\x0c', '<BR>', msg)
			if pkt['type'] == ICQ_MSG_URL:
				tmp = re.split('\xFE',msg)
				tmp2 = 'Description: ' + tmp[0] + '<BR>URL: <A TARGET="_blank" HREF="' + tmp[1] + '">' + tmp[1] + '</A>'
				msg = tmp2
			elif pkt['type'] == ICQ_MSG_AUTHORIZED:
				msg = "<B>User has authorized you to add them to your contact list.  Har! Har!</B>"
			elif pkt['type'] == ICQ_MSG_ADDED_TO_LIST:
				tmp = re.split('\xFE',msg)
				msg = "<B>User has added you to their contact list.</B>"
				msg = msg + "<BR><B>Alias:</B> " + tmp[0] + "<BR><B>Name:</B> " + tmp[1] + " " + tmp[2] + "<BR><B>Email:</B> " + tmp[3]
			elif pkt['type'] == ICQ_MSG_REQ_AUTH:
				tmp = re.split('\xFE',msg)
				msg = "<B>User has requested authorization to add you to their contact list.</B>"
				msg = msg + "<BR><B>Alias:</B> " + tmp[0] + "<BR><B>Name:</B> " + tmp[1] + " " + tmp[2] + "<BR><B>Email:</B> " + tmp[3] + "<BR><B>Reason:</B><BR>" + tmp[5]
				msg = msg + '<HR><INPUT TYPE="submit" NAME="action" VALUE="Authorize">'
		        try:
				alias = peerinfo[pkt['uin']]['alias']
			except KeyError:
				alias = ''	
			t = pkt['time']
			t = time.asctime(time.localtime(t))
			if c == CMD_INSTANT_MSG:
				t = 'Received: ' + t
			
			e = '''
			<TABLE BORDER=1>
			<TD>
			<FORM METHOD="POST" ACTION="icq">
			<INPUT TYPE="hidden" NAME="my_uin" VALUE="''' + stri(my_uin) + '''">
			<INPUT TYPE="hidden" NAME="session" VALUE="''' + session_key  + '''">
			<INPUT TYPE="hidden" NAME="file" VALUE="''' + lst[i]  + '''">
			<INPUT TYPE="hidden" NAME="uin" VALUE="''' + stri(pkt['uin']) + '''">
			<B>Incoming event from: ''' + alias + ' [' + stri(pkt['uin']) + ''']</B>
			<HR>
''' + t + '''
			<HR>
''' + msg + '''			
			<HR>
			<TEXTAREA NAME="message" ROWS=3 COLS=20></TEXTAREA>
			<BR><INPUT TYPE="submit" NAME="action" VALUE="Reply">
                        <INPUT TYPE="submit" NAME="action" VALUE="Dismiss">
''' + extrabuttons + '''
			</FORM>
			</TD>
			</TABLE>
'''
			events = events + e			
##
		elif c == EVNT_EDIT_MY_INFO:
                        numsysmsgs = numsysmsgs + 1
			e = '''
			<TABLE BORDER=1>
			<TD>
			<FORM METHOD="POST" ACTION="icq">
			<INPUT TYPE="hidden" NAME="my_uin" VALUE="''' + stri(my_uin) + '''">
			<INPUT TYPE="hidden" NAME="session" VALUE="''' + session_key  + '''">
			<INPUT TYPE="hidden" NAME="file" VALUE="''' + lst[i]  + '''">
			<B>Edit Your Info:</B>
			<HR>
			Authorization:
			<SELECT NAME="authstat">
				<OPTION>------</OPTION>
				<OPTION>Need Authorization</OPTION>
				<OPTION>Always Authorize</OPTION>
			</SELECT>
			<HR>
			<BR><INPUT TYPE="submit" NAME="action" VALUE="Change Info">
                        <INPUT TYPE="submit" NAME="action" VALUE="Dismiss">
			</FORM>
			</TD>
			</TABLE>
'''
			sysevents = sysevents + e			
##
		elif c == CMD_SET_AUTH_ACK:
                        numsysmsgs = numsysmsgs + 1
			e = '''
			<TABLE BORDER=1>
			<TD>
			<FORM METHOD="POST" ACTION="icq">
			<INPUT TYPE="hidden" NAME="my_uin" VALUE="''' + stri(my_uin) + '''">
			<INPUT TYPE="hidden" NAME="session" VALUE="''' + session_key  + '''">
			<INPUT TYPE="hidden" NAME="file" VALUE="''' + lst[i]  + '''">
			<B>Set Authorization Status:</B>
			<BR>Succeeded.
			<HR>
                        <INPUT TYPE="submit" NAME="action" VALUE="Dismiss">
			</FORM>
			</TD>
			</TABLE>
'''
			sysevents = sysevents + e			
##
                f.close()

	allevents='<HR>'
	if sysevents != '':
		allevents = allevents + '<H3>System Events:</H3>' + sysevents + '<HR>'
	if events != '':
		allevents = allevents + '<H3>User Events:</H3>' + events

	if returntype == RETURN_HTML: 
		return allevents
	elif returntype == RETURN_NUMMSGS:
		return nummsgs
	elif returntype == RETURN_NUMSYSMSGS:
		return numsysmsgs

######

def get_status():
	global my_status	# my_status has already been retrieved by do_auth()
	s=[]
	for i in range(5+1):
		s.append('')
	if my_status == ICQ_STAT_ONLINE:
		s[0] = ' SELECTED'
	elif my_status == ICQ_STAT_AWAY:
		s[1] = ' SELECTED'
	elif my_status == ICQ_STAT_NA:
		s[2] = ' SELECTED'
	elif my_status == ICQ_STAT_OCCUPIED:
		s[3] = ' SELECTED'
	elif my_status == ICQ_STAT_DND:
		s[4] = ' SELECTED'
	elif my_status == ICQ_STAT_INVISIBLE:
		s[5] = ' SELECTED'
	o = '''
<SELECT NAME="status">
	<OPTION''' + s[0] + '''>Online</OPTION>
	<OPTION''' + s[1] + '''>Away</OPTION>
	<OPTION''' + s[2] + '''>Not Available</OPTION>
	<OPTION''' + s[3] + '''>Occupied</OPTION>
	<OPTION''' + s[4] + '''>Do Not Disturb</OPTION>
	<OPTION''' + s[5] + '''>Invisible</OPTION>
</SELECT>
'''
	return o

#######
	
def out_login_page(why='',show_why=''):
	if DEBUG == 1:
		print why
	if DEBUG == 2:
		sw=why
	sw=show_why
	if sw != '':
		sw='<HR><STRONG>' + sw + '</STRONG><HR>'
	print '''Content-type: text/html\n
<HTML>
<HEAD>
<TITLE>HTICQ Login</TITLE>
</HEAD>
<BODY>
''' + sw + '''
<H1>HTICQ</H1>
<H2>Login Page</H2>
<FORM METHOD="POST" ACTION="icq">
        UIN:<INPUT TYPE="text" NAME="my_uin" SIZE="10">
'''
	if CREATE_NEW != 0:
		print '<INPUT TYPE="submit" NAME="action" VALUE="Register this UIN with HTICQ">'
	print '''
        <BR>ICQ Password: <INPUT TYPE="password" NAME="my_pass" SIZE="8" MAXLENGTH="8"><BR>
	<INPUT TYPE="checkbox" NAME="takeover">Take over previous session</INPUT>
        <INPUT TYPE="submit" NAME="action" VALUE="Login">
        <INPUT TYPE="reset" VALUE="Clear Form">
</FORM>		
<HR><A HREF="icq?" TARGET="_top">Kill Frames</A>
</BODY>
</HTML>
'''
	sys.exit()

#######

def out_error_page():
	if DEBUG == 1:
		print why
	if DEBUG == 2:
		sw=why
	sw=show_why
	if sw != '':
		sw='<HR><B>' + sw + '</B><HR>'
	print '''Content-type: text/html\n
<HTML>
<HEAD>
<TITLE>Error!</TITLE>
</HEAD>
<BODY>
<H1>Error</H1>
''' + sw + '''
</BODY>
</HTML>
'''
	sys.exit()

#######

def out_refresh_page():
	print '''Content-type: text/html\n
<HTML>
<HEAD>
<META HTTP-EQUIV="refresh" CONTENT="3;URL=http://''' + http_host + script_name + '?action=Refresh&my_uin=' + stri(my_uin) + '&session=' + session_key  + '''">
<TITLE>Please wait...</TITLE>
</HEAD>
<BODY>
<CENTER>
<TABLE BORDER=1 CELLPADDING=30>
<TD>
<B>Please wait...</B>
</TD>
</TABLE>
</CENTER>
</BODY>
</HTML>
'''
	sys.exit()

#######

def out_start_page():
	print '''Content-type: text/html\n
<HTML>
<HEAD>
<META HTTP-EQUIV="refresh" CONTENT="1;URL=http://''' + http_host + script_name + '?action=Refresh&my_uin=' + stri(my_uin) + '&session=' + session_key  + '''">
<TITLE>Starting Client...</TITLE>
</HEAD>
<BODY>
<CENTER>
<TABLE BORDER=1 CELLPADDING=50>
<TD>
<B>Starting Client...  Please Wait...</B>
</TD>
</TABLE>
</CENTER>
<BR>Click
<A HREF="http://''' + http_host + script_name + '?action=Refresh&my_uin=' + stri(my_uin) + '&session=' + session_key  + '''">
here</A> if your browser won't refresh by itself.
</BODY>
</HTML>
'''
	sys.exit()

#######
 
def out_frames_page():
	print '''Content-type: text/html\n
<HTML>
<HEAD>
<TITLE>HTICQ [''' + stri(my_uin) + ''']</TITLE>
</HEAD>
<FRAMESET ROWS="70,*">
<FRAME MARGINWIDTH=10 MARGINHEIGHT=1 SRC="icq?action=StatusFrame&my_uin=''' + stri(my_uin) + '''&session=''' + session_key  + '''">
<FRAME SRC="icq?action=Refresh&my_uin=''' + stri(my_uin) + '''&session=''' + session_key  + '''">
</FRAMESET>
<NOFRAMES>
<META HTTP-EQUIV="refresh" CONTENT="5;URL=icq?action=Refresh&my_uin=''' + stri(my_uin) + '''&session=''' + session_key  + '''">
</NOFRAMES>
</HTML>
'''
	sys.exit()

#######

def out_loggingin_page():
	print '''Content-type: text/html\n
<HTML>
<HEAD>
<META HTTP-EQUIV="refresh" CONTENT="3;URL=http://''' + http_host + script_name + '?action=Refresh&my_uin=' + stri(my_uin) + '&session=' + session_key  + '''">
<TITLE>Logging in...</TITLE>
</HEAD>
<BODY>
<CENTER>
<TABLE BORDER=1 CELLPADDING=50>
<TD>
<B>Client Started.  Logging in...</B>
</TD>
</TABLE>
</CENTER>
<FORM METHOD="POST" ACTION="icq">
	<INPUT TYPE="hidden" NAME="my_uin" VALUE="''' + stri(my_uin) + '''">
	<INPUT TYPE="hidden" NAME="session" VALUE="''' + session_key  + '''">
	<INPUT TYPE="hidden" NAME="action" VALUE="Logout">
</FORM>
<BR>Click
<A HREF="http://''' + http_host + script_name + '?action=Refresh&my_uin=' + stri(my_uin) + '&session=' + session_key  + '''">
here</A> if your browser won't refresh by itself.
</BODY>
</HTML>
'''
	sys.exit()

#######

def out_logout_page():
	print '''Content-type: text/html\n
<HTML>
<HEAD>
<META HTTP-EQUIV="refresh" CONTENT="5;URL=http://''' + http_host + script_name + '''?">
<TITLE>Logging off...</TITLE>
</HEAD>
<BODY>
<CENTER>
<TABLE BORDER=1 CELLPADDING=50>
<TD>
<B>Logging off...</B>
</TD>
</TABLE>
</CENTER>
</BODY>
</HTML>
'''
	sys.exit()

#######
def out_status_frame():
	nummsgs = get_events(RETURN_NUMMSGS)
	numsysmsgs = get_events(RETURN_NUMSYSMSGS)
	if nummsgs == 0:
		s = "No Msgs"
	else:
		s = "<FONT SIZE=+7 COLOR=\"#FF0000\"><BLINK>" + stri(nummsgs) + " msgs waiting.</BLINK></FONT>"

	if numsysmsgs == 0:
		s = s + ""
	else:
		s = s + '<BR>' + stri(numsysmsgs) + ' system events waiting.'

	print '''Content-type: text/html\n
<HTML>
<HEAD>
<META HTTP-EQUIV="refresh" CONTENT="8">
<TITLE>StatusFrame</TITLE>
</HEAD>
<BODY>
<CENTER>
''' + s + '''
</CENTER>
</BODY>
</HTML>
'''
	sys.exit()

#######
def out_main_page(why='',show_why='',message=''):
	if DEBUG == 1:
		print why
	if DEBUG == 2:
		sw=why
	sw=show_why
	if sw != '':
		sw='<HR><STRONG>' + sw + '</STRONG><HR>'
	contacts=contact_list()
	events = get_events()
	status = get_status()

	print '''Content-type: text/html\n
<HTML>
<HEAD>
<TITLE>HTICQ [''' + stri(my_uin) + ''']</TITLE>
</HEAD>
<BODY>
''' + sw + '''
<H1>HTICQ [''' + stri(my_uin) + ''']</H1>
<FORM METHOD="GET" ACTION="icq">
	<INPUT TYPE="hidden" NAME="my_uin" VALUE="''' + stri(my_uin) + '''">
	<INPUT TYPE="hidden" NAME="session" VALUE="''' + session_key  + '''">
	<INPUT TYPE="submit" NAME="action" VALUE="Refresh">
	<INPUT TYPE="submit" NAME="action" VALUE="Show Status Frame">
	<INPUT TYPE="submit" NAME="action" VALUE="Logout">
<BR>''' + status + '''<INPUT TYPE="submit" NAME="action" VALUE="Change Status">
	<BR><INPUT TYPE="submit" NAME="action" VALUE="Edit Your Info">
		<TABLE BORDER=1>
		<TR COLS=2>
			<TD VALIGN="top">
				<H4>Contact List:</H4>
''' + contacts + '''
				<BR>
				<INPUT TYPE="submit" NAME="action" VALUE="Add">
				<INPUT TYPE="submit" NAME="action" VALUE="Remove">
				<INPUT TYPE="submit" NAME="action" VALUE="Info">
				<BR><INPUT TYPE="submit" NAME="action" VALUE="Authorize">

			</TD>
			<TD VALIGN="top">
				<H4>Quick Message:</H4>
				<TEXTAREA NAME="message" ROWS=8 COLS=40>''' + message + '''</TEXTAREA>
				<BR><INPUT TYPE="submit" NAME="action" VALUE="Send Message">
			</TD>
		</TR>
		</TABLE>
</FORM>
''' + events + '''
<FORM METHOD="GET" ACTION="icq">
	<INPUT TYPE="hidden" NAME="my_uin" VALUE="''' + stri(my_uin) + '''">
	<INPUT TYPE="hidden" NAME="session" VALUE="''' + session_key  + '''">
	<INPUT TYPE="submit" NAME="action" VALUE="Refresh">
	<INPUT TYPE="submit" NAME="action" VALUE="Show Status Frame">
	<INPUT TYPE="submit" NAME="action" VALUE="Logout">
</FORM>
<HR><A HREF="icq?action=Refresh&my_uin=''' + stri(my_uin) + '''&session=''' + session_key  + '''" TARGET="_top">Kill Frames</A>
</BODY>
</HTML>
'''
	sys.exit()

#######

def do_auth():
	global my_status

	try:
		f=open(data_dir+'/session/status','r')
	except IOError:
		why="Refresh: Not Logged In (status)"
		show_why="Not Logged In (possibly a timeout)"
		out_login_page(why,show_why)

	bigstat=noline(f.readline())
	try:
		my_status=long(f.readline())
	except ValueError:
		pass
	f.close()


	f=open(data_dir+'/session/key','r')
	real_key=noline(f.readline())
	real_ip=noline(f.readline())

	f.close()
	
	if session_key != real_key:
		why="bad session_key"
		out_login_page(why)
	if real_ip != remote_ip:
		why="bad ip"
		out_login_page(why)

	if bigstat == "BADPWD":
		why="Login: BADPWD"
		show_why="Bad Password"
		out_login_page(why,show_why)

	if isactive()==0:
		why="Refresh: Not Logged In (isactive)"
		show_why="Not logged in"
		out_login_page(why,show_why)
		

	if bigstat == "START":
		out_start_page()
	elif bigstat == "LOGIN":
		out_loggingin_page()
	elif bigstat == "READY":
		return false
	else:
		why="unknown status"
		out_login_page(why)





########
# main #
########

my_status = ICQ_STAT_OFFLINE
peerinfo = {}

postdata = sys.stdin.read()	# Read POST results
if postdata == '':		# Return the login page
	postdata=getenv('QUERY_STRING')
	if postdata == '':
		why='no data'
		out_login_page(why)

parameters = split_vars(postdata)

action = getparam(parameters,'action')
session_key = getparam(parameters,'session')
my_uin = getparam(parameters,'my_uin')
my_pass = getparam(parameters,'my_pass')
takeover = ( getparam(parameters,'takeover') == 'on' )
hticq_pass = getparam(parameters,'hticq_pass')

script_name = getenv('SCRIPT_NAME')	
remote_ip = getenv('REMOTE_ADDR')
http_host = getenv('HTTP_HOST')

data_dir = 'data/' + stri(my_uin)

if action == '' or my_uin == '':
	why='no action/my_uin'
	out_login_page(why)

try:
	my_uin=long(my_uin)
except ValueError:
	why='bad my_uin'
	show_why="Bad UIN"
	out_login_page(why,show_why)

if my_uin<1000:
	why="Low UIN"
	show_why="Bad UIN"
	out_login_page(why,show_why)

if action != "Register this UIN with HTICQ" and action != "Login":
	do_auth()

if action == "Register this UIN with HTICQ":
	try:
		os.stat(data_dir)
	except OSError:
		if CREATE_NEW != 0:
			os.mkdir(data_dir)
			os.system('cp -r data/skel/* ' + data_dir)
			why="Login: Registered"
			show_why="UIN Registered with HTICQ.  Proceed with Login."
			out_login_page(why,show_why)
		else:
			why="Login: UIN reg. not allowed"
			show_why="UIN Registration Not Allowed"
			out_login_page(why,show_why)


elif action == 'Login':
	try:
		os.stat(data_dir)
	except OSError:
		why="Login: UIN not registered"
		show_why="UIN is not registered with HTICQ"
		out_login_page(why,show_why)

	if takeover:
		if not good_password(parameters['my_pass']):
			why="Takeover: BADPWD"
			show_why="Takeover: Bad password or not logged in."
			out_login_page(why,show_why)
			

	if isactive() and not takeover:
		why="Login: Already Logged in"
		show_why="Already logged in"
		if isactive():
			why = why+": isactive() returned true"
			show_why = show_why+": isactive() returned true"
		out_login_page(why,show_why)

	session_key=gen_session_key()
	f=open(data_dir+'/session/key','w')
	f.write(session_key + "\n")
	f.write(remote_ip + "\n")
	f.close()

	if not takeover:
		f=open(data_dir+'/session/status','w')
		f.write("START\n")
		f.close()
	        e=1
	        while e:
	                r = random_string(8)
	                file = 'data/logintemp/' + r
	                if exists(file):
	                        e=1
	                else:   
	                        e=0
		
		f=open(file,'w')
		f.write(parameters['my_pass'] + "\n")
		f.close()
		os.system('sh ./starticq.sh ' + parameters['my_uin'] + ' ' + r)

	out_start_page()

elif action == 'Refresh':	
	a = {'cmd': 'NOP'}	# Keeps client alive
	write_event(a)
	out_main_page(message=getparam(parameters, 'message'))
elif action == 'Show Status Frame':	
	a = {'cmd': 'NOP'}	# Keeps client alive
	write_event(a)
	out_frames_page()
elif action == 'Dismiss':
	a = {'cmd': 'NOP'}	# Keeps client alive
	write_event(a)
	try:
		file=parameters['file']
		if len(re.findall('['+VALID_CHARS+']', file)) != len(file):
			why="Dismiss: Invalid file chars"
			show_why=''
			out_error_page()
		os.unlink(data_dir + '/session/events/c2i/' + file)
	except OSError:
		pass
	out_main_page()
elif action == 'Reply':
	a = {'cmd': 'NOP'}	# Keeps client alive
	write_event(a)
	try:
		file=getparam(parameters,'file')
		if len(re.findall('['+VALID_CHARS+']', file)) != len(file):
			why="Dismiss: Invalid file chars"
			show_why=''
			out_error_page()
		a = {'cmd': 'MESSAGE', 'uin': long(getparam(parameters,'uin')),
		     'type': ICQ_MSG_TEXT, 'message': getparam(parameters, 'message')}
		write_event(a)
		os.unlink(data_dir + '/session/events/c2i/' + file)
	except OSError:
		pass
	out_main_page()
elif action == 'Send Message':
	a = {'cmd': 'NOP'}	# Keeps client alive
	write_event(a)
	uin=long(getparam(parameters,'uin'))
	if uin==0:
		try:
			uin=long(getparam(parameters,'other_uin'))
		except ValueError:
			w="bad or empty other_uin"
			sw="UIN invalid or not specified."
			out_main_page(w,sw,getparam(parameters, 'message'))
	
	a = {'cmd': 'MESSAGE', 'uin': uin,
	     'type': ICQ_MSG_TEXT, 'message': getparam(parameters, 'message')}
	write_event(a)
	out_main_page()
elif action == 'Add' or action == 'Add to Contact List':
	a = {'cmd': 'NOP'}	# Keeps client alive
	write_event(a)
	get_peerinfo()
	uin=long(getparam(parameters,'uin'))
	if uin==0:
		try:
			uin=long(getparam(parameters,'other_uin'))
		except ValueError:
			w="bad or empty other_uin"
			sw="UIN invalid or not specified."
			out_main_page(w,sw)
	w="Add: Contact exists"
	sw="UIN is already on your contact list."
	try:
		tmp=peerinfo[uin]
	except KeyError:
		f = open(data_dir + '/contacts','a')
		f.write(stri(uin) + '\n')
		f.close()
		a = {'cmd': 'RELOAD_CONTACTS'}
		write_event(a)	
		out_refresh_page()
	out_main_page(w,sw)
elif action == 'Remove':
	a = {'cmd': 'NOP'}	# Keeps client alive
	write_event(a)
	get_peerinfo()
	uin=long(getparam(parameters,'uin'))
	if uin==0:
		try:
			uin=long(getparam(parameters,'other_uin'))
		except ValueError:
			w="bad or empty other_uin"
			sw="UIN invalid or not specified."
			out_main_page(w,sw)
	
	try:
		tmp=peerinfo[uin]
	except KeyError:
		w="Remove: Contact does not exist"
		sw="UIN is not on your contact list."
		out_main_page(w,sw)
	e=1
	while e:
		r = random_string(8)
		file = data_dir + '/contacts.' + r
		if exists(file):
			e=1
		else:
			e=0

	f = open(data_dir + '/contacts','r')
	g = open(file, 'w')
	x=' '
	while x != '':
		x=f.readline()
		if x != '':
			y=long(noline(x))
			if y != uin:
				g.write(x)
	f.close()
	g.close()

	copy_file(file,data_dir + '/contacts')
	os.unlink(file)

	a = {'cmd': 'RELOAD_CONTACTS'}
	write_event(a)	
	out_refresh_page()

elif action == 'Authorize':
	a = {'cmd': 'NOP'}	# Keeps client alive
	write_event(a)
	uin=long(getparam(parameters,'uin'))
	if uin==0:
		try:
			uin=long(getparam(parameters,'other_uin'))
		except ValueError:
			w="bad or empty other_uin"
			sw="UIN invalid or not specified."
			out_main_page(w,sw,getparam(parameters, 'message'))
	
	a = {'cmd': 'MESSAGE', 'uin': uin,
	     'type': ICQ_MSG_AUTHORIZED, 'message': ''}
	write_event(a)
	try:
		file=parameters['file']
		if len(re.findall('['+VALID_CHARS+']', file)) != len(file):
			why="Dismiss: Invalid file chars"
			show_why=''
			out_error_page()
		os.unlink(data_dir + '/session/events/c2i/' + file)
	except OSError:
		pass
	except KeyError:
		pass
	out_main_page(message=getparam(parameters, 'message'))

elif action == "Change Status":
	global my_status
	tmp = getparam(parameters,'status')
	s = my_status
	if tmp == "Online":
		s = ICQ_STAT_ONLINE
	elif tmp == "Away":
		s = ICQ_STAT_AWAY
	elif tmp == "Not Available":
		s = ICQ_STAT_NA
	elif tmp == "Occupied":
		s = ICQ_STAT_OCCUPIED
	elif tmp == "Do Not Disturb":
		s = ICQ_STAT_DND
	elif tmp == "Invisible":
		s = ICQ_STAT_INVISIBLE

	a = {'cmd': 'CHANGE_STATUS', 'status': s}
	write_event(a)
	my_status = s
	out_main_page(message=getparam(parameters, 'message'))

elif action == "Change Info":
	tmp = getparam(parameters,'authstat')
	s=-1
	if tmp == "Need Authorization":
		s = ICQ_AUTH_AUTH
	elif tmp == "Always Authorize":
		s = ICQ_AUTH_ALWAYS

	print "A: " + stri(s)
	if s != -1:
		a = {'cmd': 'SET_AUTH', 'authstat': s}
		write_event(a)

	try:
		file=parameters['file']
		if len(re.findall('['+VALID_CHARS+']', file)) != len(file):
			why="Dismiss: Invalid file chars"
			show_why=''
			out_error_page()
		os.unlink(data_dir + '/session/events/c2i/' + file)
	except OSError:
		pass

	out_main_page()
	
elif action == "Edit Your Info":

	pkt = {'cmd': EVNT_EDIT_MY_INFO}
	write_packet(pkt,inprg=IN_PROGRAM)
	out_main_page(message=getparam(parameters, 'message'))
	
elif action == 'Info':
	a = {'cmd': 'NOP'}	# Keeps client alive
	write_event(a)
	w="Info: NOP"
	sw="That function is not yet implemented."
	out_main_page(w,sw)

elif action == 'StatusFrame':
	a = {'cmd': 'NOP'}	# Keeps client alive
	write_event(a)
	out_status_frame()

elif action == 'Logout':
	a={'cmd': 'LOGOUT'}
	write_event(a)
	out_logout_page()
	

print "Content-type: text/plain\n"
print "*** End of Program ***"
sys.exit()

